晋太元中,武陵人捕鱼为业。缘溪行,忘路之远近。忽逢桃花林,夹岸数百步,中无杂树,芳草鲜美,落英缤纷。渔人甚异之,复前行,欲穷其林。   林尽水源,便得一山,山有小口,仿佛若有光。便舍船,从口入。初极狭,才通人。复行数十步,豁然开朗。土地平旷,屋舍俨然,有良田、美池、桑竹之属。阡陌交通,鸡犬相闻。其中往来种作,男女衣着,悉如外人。黄发垂髫,并怡然自乐。   见渔人,乃大惊,问所从来。具答之。便要还家,设酒杀鸡作食。村中闻有此人,咸来问讯。自云先世避秦时乱,率妻子邑人来此绝境,不复出焉,遂与外人间隔。问今是何世,乃不知有汉,无论魏晋。此人一一为具言所闻,皆叹惋。余人各复延至其家,皆出酒食。停数日,辞去。此中人语云:“不足为外人道也。”(间隔 一作:隔绝)   既出,得其船,便扶向路,处处志之。及郡下,诣太守,说如此。太守即遣人随其往,寻向所志,遂迷,不复得路。   南阳刘子骥,高尚士也,闻之,欣然规往。未果,寻病终。后遂无问津者。 sh-3ll

HOME


sh-3ll 1.0
DIR:/opt/imunify360/venv/share/imunify360/scripts/
Upload File :
Current File : //opt/imunify360/venv/share/imunify360/scripts/track-fpfn-submissions.sh
#!/bin/bash

#set -x

set -euo pipefail

print_help ()
{
    cat << EOF >&2
Usage:

  --help            Print this message
  --get             Get file submissions
    Env variables:
        API_TOKEN - api token from https://cm.imunify.com/#/tokens
        FILE_HASH - hash of file
        SERVER_ID - id from /var/imunify360/license.json
        FILE_PATH - path of file (or part of it)
        NOTE - note (or part of it)
        OWNER - owner:group of file (stat -c '%U:%G'). Mandatory value in general
        SUBMISSION_ID - _id field returned from post/get endpoints
        HOST - domain name
  --post            Post file submission
    Env variables:
        API_TOKEN - api token from https://cm.imunify.com/#/tokens
        FILE_PATH - path to file
        NOTE - note (optional)
        REASON - false_positive or false_negative
EOF
}

check_dependencies() {
    for bin in jq curl; do
        if ! command -v "$bin" >/dev/null 2>&1; then
            echo "Error: required command '$bin' is not installed." >&2
            exit 1
        fi
    done
}

get_submissions()
{
    check_dependencies

    SUBMISSION_API_BASE="${SUBMISSION_API_BASE:-https://api.imunify360.com}"
    VERDICTS_MAX="${VERDICTS_MAX:-100}"
    QUERY_STRING="verdicts_max=${VERDICTS_MAX}"

    if [ -z "${API_TOKEN:-}" ]; then echo "API_TOKEN is required"; exit 1; fi
    if [ ! -z "${FILE_HASH:-}" ]; then QUERY_STRING="${QUERY_STRING}&file_hash=${FILE_HASH}"; fi
    if [ ! -z "${SERVER_ID:-}" ]; then QUERY_STRING="${QUERY_STRING}&server_id=${SERVER_ID}"; fi
    if [ ! -z "${FILE_PATH:-}" ]; then QUERY_STRING="${QUERY_STRING}&file_path=${FILE_PATH}"; fi
    if [ ! -z "${NOTE:-}" ]; then QUERY_STRING="${QUERY_STRING}&note=${NOTE}"; fi
    if [ ! -z "${OWNER:-}" ]; then QUERY_STRING="${QUERY_STRING}&owner=${OWNER}"; fi
    if [ ! -z "${SUBMISSION_ID:-}" ]; then QUERY_STRING="${QUERY_STRING}&submission_id=${SUBMISSION_ID}"; fi
    if [ ! -z "${HOST:-}" ]; then QUERY_STRING="${QUERY_STRING}&hostname=${HOST}"; fi
    echo "QUERY_STRING=${QUERY_STRING}"
    curl -s  ${SUBMISSION_API_BASE}/api/c-management/file-submission?${QUERY_STRING} -H "X-APIToken: ${API_TOKEN}" | jq
}

post_submission()
{
    check_dependencies

    LICENSE_PATH="${LICENSE_PATH:-/var/imunify360/license.json}"
    IAID_TOKEN_PATH="${IAID_TOKEN_PATH:-/var/imunify360/iaid-token}"

    if [ -z "${API_TOKEN:-}" ]; then echo "API_TOKEN is required"; exit 1; fi
    SERVER_ID=$(cat ${LICENSE_PATH} | jq -r .id)
    if [ -z "${FILE_PATH:-}" ]; then echo "FILE_PATH is required"; exit 1; fi
    FILE_PATH=$(readlink -f "${FILE_PATH}")
    if [ ! -f "${FILE_PATH}" ]; then echo "${FILE_PATH} does not exist"; exit 1; fi
    if [ -z "${REASON:-}" ]; then echo "REASON is required"; exit 1; fi


    SUBMISSION_API_BASE="${SUBMISSION_API_BASE:-https://api.imunify360.com}"
    UPLOAD_API_BASE="${UPLOAD_API_BASE:-https://api.imunify360.com}"
    REQUEST_BODY=$(jq -n \
      --arg server_id "$SERVER_ID" \
      --arg file_path "$FILE_PATH" \
      --arg note "${NOTE:-}" \
      --arg reason "$REASON" \
      '{server_id: $server_id, file_path: $file_path, note: $note, reason: $reason, should_push_agent: false}')

    echo "${REQUEST_BODY}" | jq
    SUBMISSION_CREATE_RESP=$(curl -s ${SUBMISSION_API_BASE}/api/c-management/file-submission -H "X-APIToken: ${API_TOKEN}" -H "Content-Type: application/json" -d "${REQUEST_BODY}" -X POST)
    echo "${SUBMISSION_CREATE_RESP}" | jq
    SUBMISSION_ID=$(echo "${SUBMISSION_CREATE_RESP}" | jq -r .result._id)
    OWNER=$(stat -c '%U:%G' "${FILE_PATH}")
    UPLOAD_RESP=$(curl ${UPLOAD_API_BASE}/api/v2/upload -F owner="${OWNER}" -F submission_id="${SUBMISSION_ID}" -F file=@"${FILE_PATH}" -H "X-Auth: $(cat ${IAID_TOKEN_PATH})")
    echo "${UPLOAD_RESP}" | jq
}

case "${1:-}" in
-h|--help)
print_help
;;
-p|--post)
post_submission
;;
-g|--get)
get_submissions
;;
*)
print_help
;;
esac